source: projects/vbootstrap/trunk/vbuilder.sh.in @ 6010

Revision 6010, 30.3 KB checked in by munepi, 12 years ago (diff)

reduce the frequency of running apt-get-chroot

RevLine 
[118]1#!/bin/bash
2# -*- coding: utf-8-unix -*-
3
[2522]4TEXTDOMAIN=vbootstrap
5TEXTDOMAINDIR=/usr/share/locale
6
[2516]7Usage(){
[118]8    cat<<EOF
[3675]9$(basename $0) @@VBUILDER_VERSION@@ $(echo $([ -z "@@VBUILDER_REVISION@@" ] || echo "(r@@VBUILDER_REVISION@@)"))
[5510]10Usage:  $(basename $0) {--profile [profile]} {--version [version]} {--arch [arch]} {--category [categories]} {--fetch-url [fetch_url]} {--dist-upgrade} {--target [target]} {--no-build-essential} {--with-compat32} {--rpmbuild-define [macro_expr]} {--rpmbuild-with [bcond_with]} {--rpmbuild-without [bcond_with]} {--sign} {--no-install} {--debug} {--help} {--bootstrap-dir [directory]} {--unionfs-dir [directory]} {--cache-dir [directory]} {--built-rpms-dir [directory]} {clean|build|build-rpm [src.rpm]|install-rpm [arch.rpm|package]|remove-rpm [package]}
[4076]11EOF
[411]12
[4076]13    echo $"
[411]14Options:
[5364]15        --profile:              set a profile
[5450]16        --version:              set [version] (default: ${VERSION})
[2718]17        --arch:                 set [arch] (default: ${UARCH})
[791]18        --category:             set [categories] (default: ${CATEGORIES})
[5364]19        --fetch-url:            set [fetch_url] to fetch packages (default: ${VBOOTSTRAP_FETCH_URL})
[412]20        --dist-upgrade:         make VineSeed bootstrap via ${STABLE_VERSION}
[791]21        --unionfs:              cover a bootstrap with unionfs
[406]22        --target:               build rpms with [target]
[5508]23        --no-build-essential:   do not install build-essential
[3850]24        --with-compat32:        build rpms with compat32 on bootstrap
[2531]25        --rpmbuild-define:      give a option --define [macro_expr] to rpmbuild
[1476]26        --rpmbuild-with:        give a option --with [bcond_with] to rpmbuild
[2531]27        --rpmbuild-without:     give a option --without [bcond_with] to rpmbuild
[1240]28        --sign:                 sign built rpms
[1267]29        --no-install:           build only a source rpm - do NOT install a built rpm
[2718]30        --login:                login in chroot as root user
[709]31        --bootstrap-dir:        set a bootstrap directory (default: ${VBOOTSTRAP_DIR})
[2711]32        --unionfs-dir:          set a directory to store unionfs images of vbootstrap (default: ${UNIONFS_DIR})
[725]33        --cache-dir:            set a directory to cache rpms (default: ${CACHE_DIR})
[709]34        --built-rpms-dir:       set a directory to store built rpms in chroot (default: ${BUILT_RPMS_DIR})
[2718]35        --debug:                enable debug mode
36        --help:                 show this help
[4076]37"
[411]38
[4076]39    echo $"
[411]40Actions:
[3850]41        clean:                  clean the bootstrap of [version]
42        build:                  build a bootstrap of [version]
[5367]43        build-rpm:              build [src.rpm] on a bootstrap
[3850]44        install-rpm:            install [arch.rpm|package] on a bootstrap
45        remove-rpm:             remove [package] on a bootstrap
[4076]46"
[118]47
[4076]48    echo $"
[3968]49Examples:
[304]50* make a clean/plain build environment on the current archtecture:
[802]51$(basename $0) clean build
[470]52* build rpms from the specified source rpm:
[802]53$(basename $0) build-rpm [src.rpm]
[3676]54* make a plain build environment for Vine Linux 5.2:
55$(basename $0) --version 5.2 clean build
[304]56* make a i386 chroot on x86_64:
[802]57$(basename $0) --arch i386 clean build
58* build a kernel package with target i686:
59$(basename $0) --target i686 build-rpm [kernel src.rpm]
[406]60* build a compat32 package:
[802]61$(basename $0) --arch i386 --with-compat32 build-rpm [src.rpm]
[4076]62"
63    /usr/sbin/vbootstrap | sed -e s/^Usage:.*// -e s/^E:.*//
[5364]64## TODO: output supported profiles and their names/comments
[118]65}
66
[323]67##############################################################################
68
[5364]69initialize-variables(){
70    ## set boolian variables
71    with_profile=0
72    with_setup_vbootstrap=0
73    with_dist_upgrade=0
74    with_unionfs=0
75    with_sign=0
76    with_no_install=0
77    with_login=0
78    with_debug=0
79    with_actions=0
80    with_ix86_on_x86_64=0
81    with_category_main=0
82    with_category_plus=0
83    with_category_nonfree=0
84    with_category_test=0
85    with_category_proposed_updates=0
86    with_category_security=0
[5508]87    with_build_essential=1
[5364]88
89    return 0
90}
91
[416]92check-parameter(){
[2516]93    [ -z "$*" ] && Usage && return 1
[416]94
95    while [ ! -z "$*" ]; do
96        case $1 in
[725]97            --help|help)
[5367]98                setup-vbuilder ||:
[2516]99                Usage
[517]100                return 1
[516]101                ;;
[5364]102            --profile)
103                shift
104                with_profile=1
105                PROFILE=$1
106                check-next-parameter $1 || return 1
107                ;;
108            --version|--arch|--category|--fetch-url|--target|--rpmbuild-define|--rpmbuild-with|--rpmbuild-without|--bootstrap-dir|--unionfs-dir|--cache-dir|--built-rpms-dir)
[725]109                [ $with_actions -eq 1 ] && \
[2516]110                    echo $"E: You can give no more options after actions" && \
111                    return 1
[416]112                shift
113                check-next-parameter $1 || return 1
114                ;;
[5508]115            --dist-upgrade|--unionfs|--with-compat32|--sign|--no-install|--login|--no-build-essential|--debug)
[725]116                [ $with_actions -eq 1 ] && \
[2516]117                    echo $"E: You can give no more options after actions" && \
118                    return 1
[416]119                ;;
[725]120            --build-rpm|build-rpm|--install-rpm|install-rpm|--remove-rpm|remove-rpm)
121                with_actions=1
122                shift
123                check-next-parameter $1 || return 1
124                ;;
[3675]125            --build|build|--clean|clean)
[725]126                with_actions=1
127                ;;
[416]128            *)
[2516]129                echo $"E: Missing some parameters after $1"
[416]130                return 1
131                ;;
132        esac
133        shift
134    done
[725]135
[2516]136    [ $with_actions -eq 0 ] && \
137        echo $"E: You must give at least one action" && return 1
[725]138
[416]139    return 0
140}
141
[412]142check-next-parameter(){
[2516]143    [ -z "$1" ] && echo $"E: Missing some parameters after $1" && return 1
[416]144
[2516]145    [ $(echo $1 | grep '^-') ] && \
146        echo $"E: Missing some parameters after $1" && return 1
[725]147
[412]148    return 0
149}
150
[5364]151## NOTE: setup-vbuilder() loads
152##  - system wide configurations (from /etc/vbootstrap/vbuilder.conf)
153##  - given profile (from /etc/vbootstrap/profile.d/*.conf)
154##  - given command-line parameters
155## where given command-line parameters override the settings given profile,
156## and the settings given profile override system wide settings.
157## If you use a profile of vbuilder, you may not override the settings
158## given profile.
[323]159setup-vbuilder(){
[3343]160    ## check $SUDO_USER and $USERHELPER_UID
161    RPM_SIGN_USER=$SUDO_USER
162    if [ -z "${RPM_SIGN_USER}" ]; then
[3967]163        [ -z "${USERHELPER_UID}" ] && \
164            echo $"W: \$SUDO_USER and \$USERHELPER_UID are empty" && \
165            return 1
166           
[3352]167        RPM_SIGN_USER=$(getent passwd $USERHELPER_UID | cut -d":" -f1)
[3343]168    fi
169    ## get $RPM_SIGN_USER's home directory
170    HOME=$(getent passwd $RPM_SIGN_USER |  cut -d":" -f6)
171
[323]172    ## load default settings
[725]173    VBUILDER_CONF=/etc/vbootstrap/vbuilder.conf
174    if [ -r $VBUILDER_CONF ]; then
175        . $VBUILDER_CONF
[1240]176        [ $? -eq 1 ] && return 1
[323]177    fi
[791]178    [ -z "${CATEGORIES}" ] && \
179        CATEGORIES=@@VBUILDER_CATEGORIES@@
[5364]180    [ -z "${VBOOTSTRAP_FETCH_URL}" ] && \
181        VBOOTSTRAP_FETCH_URL=@@VBUILDER_VBOOTSTRAP_FETCH_URL@@
[330]182    [ -z "${VBOOTSTRAP_DIR}" ] && \
183        VBOOTSTRAP_DIR=@@VBUILDER_VBOOTSTRAP_DIR@@
[2711]184    [ -z "${UNIONFS_DIR}" ] && \
185        UNIONFS_DIR=@@VBUILDER_UNIONFS_DIR@@
[725]186    [ -z "${CACHE_DIR}" ] && \
187        CACHE_DIR=@@VBUILDER_CACHE_DIR@@
[370]188    [ -z "${BUILT_RPMS_DIR}" ] && \
189        BUILT_RPMS_DIR=@@VBUILDER_BUILT_RPMS_DIR@@
[709]190
[5368]191    ## set default version for vbootstrap
192    VERSION=@@VBUILDER_DEFAULT_VERSION@@
193
[5364]194    ## load profile
195    if [ ${with_profile} -eq 1 ]; then
196        [ ! -r /etc/vbootstrap/profile.d/${PROFILE}.conf ] && \
197            echo $"E: No such profile found: ${PROFILE}" && return 1
198
199        . /etc/vbootstrap/profile.d/${PROFILE}.conf
200        [ $? -eq 1 ] && return 1
201    fi
202
[709]203    ## set current stable relase version
[411]204    STABLE_VERSION=@@VBUILDER_STABLE_VERSION@@
205
[3676]206    ## set default chroot archtecture
207    UARCH=$(uname -i)
208    case "${UARCH}" in
209        arm*)
210            UARCH="arm"
211            ;;
212    esac
213
[1240]214    return 0
[323]215}
216
[118]217setup-vbootstrap(){
[411]218    if [ ${with_setup_vbootstrap} -eq 0 ]; then
219        with_setup_vbootstrap=1
[118]220
[2718]221        ## check debug mode
222        [ ${with_debug} -eq 1 ] && \
[3675]223            cat $VBUILDER_CONF && \
[2718]224            set && set -x
225
[725]226        ## check some directories
227        ## Note: create $BUILT_RPMS_DIR in RPM_Build()
[709]228        [ -d $VBOOTSTRAP_DIR ] || mkdir -p $VBOOTSTRAP_DIR
[725]229        [ -d $CACHE_DIR ] || mkdir -p $CACHE_DIR
[709]230
[3676]231        ## check chroot version
232        case ${VERSION} in
[4072]233            4.2|5.2|6.0|VineSeed)
[2718]234                ;;
[3676]235            *)
236                echo $"E: ${VERSION} is NOT supported"
237                return 1
238                ;;
[2718]239        esac
240
241        case "${VARCH}" in
242            arm*)
243                VARCH="arm"
244                ;;
245        esac
246
[304]247        ## check a chroot archtecture
[725]248        if [ -z ${VARCH} ]; then
[2718]249            VARCH=${UARCH}
[725]250        else
[304]251            case "${VARCH}" in
[3676]252                i386|x86_64)
253                    [ "${UARCH}" = "ppc" -o "${UARCH}" = "arm" ] && \
254                        echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
[304]255                    ;;
256                ppc)
[3676]257                    [ "${UARCH}" = "i386" -o "${UARCH}" = "x86_64" -o "${UARCH}" = "arm" ] && \
258                        echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
[304]259                    ;;
[2718]260                arm)
[3676]261                    [ "${UARCH}" = "i386" -o "${UARCH}" = "x86_64" -o "${UARCH}" = "ppc" ] && \
[2718]262                        echo $"E: arch ${VARCH} is NOT supported on ${UARCH}" && return 1
263                    ;;
[304]264            esac
[323]265        fi
266
[3676]267        ##!! 4.2 is NO support on VARCH=x86_64 or VARCH=arch
268        if [ "${VERSION}" = "4.2" ]; then
269            if [ "${VARCH}" = "x86_64" -o "${VARCH}" = "arm" ]; then
270                echo $"E: ${VERSION}_${VARCH} is NOT supported"
271                return 1
272            fi
[323]273        fi
274
[5364]275        ## set base profile <version>_<arch>
276        BASE_PROFILE=${VERSION}_${VARCH}
[2718]277
[5364]278        ## check support ${BASE_PROFILE}
279        if [ -z "$(/usr/sbin/vbootstrap | sed -e s/^Usage:.*// -e s/^E:.*// | grep -m 1 ${BASE_PROFILE})" ]; then
280            echo $"E: ${BASE_PROFILE} is NOT supported"
[2516]281            return 1
[323]282        fi
283
[411]284        ## check ${VERSION} equals VineSeed*, when with_dist_upgrade=1
285        if [ $with_dist_upgrade -eq 1 ]; then
[3676]286            if [ "${VERSION}" != "VineSeed" ]; then
[2516]287                echo $"E: version ${VERSION} does not support --dist-upgrade option"
288                return 1
[411]289            fi
290        fi
291
[3676]292        ## support i386 chroot on x86_64 below:
293        [ "${UARCH}" = "x86_64" -a "${VARCH}" = "i386" ] && \
294            with_ix86_on_x86_64=1
[791]295
296        ## check apt categories
[800]297        ## "main" category is unconditionally permited
[791]298        with_category_main=1
299        for cat in $(echo ${CATEGORIES} | sed -e "s/,/ /"g); do
300            case $cat in
301                main)
302                    with_category_main=1
303                    ;;
304                plus)
305                    with_category_plus=1
306                    ;;
307                nonfree)
308                    with_category_nonfree=1
309                    ;;
[800]310                test)
311                    ## "test" category only exists in VineSeed
[3676]312                    [ "${VERSION}" = "VineSeed" ] || \
[2516]313                        echo $"E: No such category exists: $cat" && return 1
[800]314                    with_category_test=1
315                    ;;
[791]316                proposed-updates)
[800]317                    ##!! "proposed-updates" category does not exist in 4.2
[3676]318                    [ "${VERSION}" = "4.2" ] && \
[2516]319                        echo $"E: No such category exists: $cat" && return 1
[791]320
321                    with_category_proposed_updates=1
322                    ;;
[800]323                security)
324                    ## "security" category does not exist in VineSeed
[3676]325                    [ "${VERSION}" = "VineSeed" ] && \
[2516]326                        echo $"E: No such category exists: $cat" && return 1
[800]327                    with_category_security=1
328                    ;;
[791]329                *)
[2516]330                    echo $"E: No such category exists: $cat" && return 1
[791]331                    ;;
332            esac
333        done
334
[406]335        ## check build target option ${TARGET}
[407]336        if [ ! -z "${TARGET}" ]; then
337            RPM_TARGET_LIST="$(cat /usr/lib/rpm/rpmrc | grep arch_canon: | sed -e "s/arch_canon:[[:blank:]]*\(.*\):.*/\1/")"
[3742]338            RPM_TARGET_LIST="${RPM_TARGET_LIST} noarch"
339            if [ -z "$(echo ${RPM_TARGET_LIST} | grep ${TARGET})" ]; then
[2516]340                echo $"E: rpm build target ${TARGET} is NOT supported"
341                return 1
[407]342            fi
[406]343        fi
344
[1240]345        ## set ${RPM_PKG_ARCH_LIST}
[5364]346        RPM_PKG_ARCH_LIST=" \
347            RPMS/i386 RPMS/i486 RPMS/i586 RPMS/i686 RPMS/x86_64 RPMS/ppc \
348            RPMS/noarch \
349            RPMS/armv3l RPMS/armv4l RPMS/armv4tl \
350            RPMS/armv5tejl RPMS/armv5tel RPMS/armv6l RPMS/armv7l \
351            SRPMS"
[1240]352        [ -z "${TARGET}" ] || \
353            RPM_PKG_ARCH_LIST="RPMS/${TARGET} ${RPM_PKG_ARCH_LIST}"
354
[135]355    fi
[323]356
[1240]357    ## set global variables
[296]358    BUILD_USER=vbuilder
359    BUILD_DIR=/home/${BUILD_USER}/rpm
[5364]360    if [ ${with_profile} -eq 1 ]; then
361        BUILD_ROOT=${VBOOTSTRAP_DIR}/${PROFILE}
362        UNIONFS_ROOT=${UNIONFS_DIR}/${PROFILE}
363    else
364        BUILD_ROOT=${VBOOTSTRAP_DIR}/${BASE_PROFILE}
365        UNIONFS_ROOT=${UNIONFS_DIR}/${BASE_PROFILE}
366    fi
[452]367    ARCHIVES_DIR=${BUILD_ROOT}/var/cache/apt/archives
[5364]368    EXTERNAL_ARCHIVES_DIR=${CACHE_DIR}/${BASE_PROFILE}/apt/archives
[135]369
[2468]370    __chroot_sh="/usr/sbin/chroot ${BUILD_ROOT} /bin/sh -c -l"
[453]371
[135]372    mkdir -p $VBOOTSTRAP_DIR
[1240]373
374    return 0
[118]375}
376
[412]377setup-vbootstrap-rpm(){
[1240]378    setup-vbootstrap || return 1
[412]379
380    ## check ${BUILD_ROOT}
381    [ -d ${BUILD_ROOT} ] || Build
[2324]382    ## setarch ix86 if ix86 chroot on x86_64 host
383    [ $with_ix86_on_x86_64 -eq 1 ] && \
[2468]384        __chroot_sh="/usr/sbin/chroot ${BUILD_ROOT} setarch ${VARCH} /bin/sh -c -l"
[412]385
386    DIST_RELEASE=$(cat ${BUILD_ROOT}/etc/vine-release | cut -f3 -d" " | cut -f1 -d.)
387
388    if [ -f $RPM_PKG ]; then
389        BASE_RPM_PKG=$(basename $RPM_PKG)
390        cp -f $RPM_PKG $BUILD_ROOT${BUILD_DIR}
391    else
392        BASE_RPM_PKG=$RPM_PKG   
393    fi
[1240]394
395    return 0
[412]396}
397
[413]398## recover apt-get data on host/chroot
399apt-get-update(){
400    case $1 in
401        --host)
[2522]402            echo -n $"apt-get update on host ... "
[464]403            apt-get -qq update > /dev/null 2>&1
[2522]404            echo $"done."
[413]405            ;;
406        --chroot)
[2522]407            echo -n $"apt-get update on chroot ... "
[464]408            $__chroot_sh 'apt-get -qq update' > /dev/null 2>&1
[2522]409            echo $"done."
[413]410            ;;
411        *)
412            echo apt-get-update: unknown option $1
413            exit 1
414            ;;
415    esac
416}
417
[454]418## mount-chroot {|--umount} [file system|name]
419## support file systems: /home /tmp /sys /proc /dev/shm /dev/pts /dev
[2654]420## support names: vfs archives_dir
[454]421## NOTE: /tmp needs for applications which use X
422##       vfs is virtual file systems
[851]423##       archives_dir uses to mount ${EXTERNAL_ARCHIVES_DIR} to ${ARCHIVES_DIR}
424##       unionfs_dir covers ${BUILD_ROOT} with unionfs
[454]425mount-chroot(){
[412]426    if [ "$1" = "--umount" ]; then
[454]427        mount-chroot-umount $2 || return 1
[412]428    else
[454]429        mount-chroot-mount $1 || return 1
[412]430    fi
[454]431    return 0
[412]432}
433
[454]434## mount-chroot-umount [file system|name]
435mount-chroot-umount(){
436    local fs=$1
437    case $fs in
438        /home|/tmp|/sys|/proc|/dev/shm|/dev/pts|/dev)
439            [ -d ${BUILD_ROOT}${fs} ] || return 1
440            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] || \
441                umount ${BUILD_ROOT}${fs}
[2654]442            if [ ! -z "$(mount | grep ${BUILD_ROOT}${fs})" ]; then
443                echo $"Retry lazy unmount ${BUILD_ROOT}${fs} ... "
444                umount -l ${BUILD_ROOT}${fs}
445                echo $"done."
446            fi
[454]447            ;;
448        vfs)
[2718]449            for dir in /sys /proc /dev/shm /dev/pts /dev; do
450                mount-chroot-umount ${dir} || return 1
451            done
[454]452            ;;
[725]453        archives_dir)
[454]454            [ -d ${ARCHIVES_DIR} ] || return 1
455            [ -z "$(mount | grep ${ARCHIVES_DIR})" ] || \
456                umount ${ARCHIVES_DIR}
457            ;;
[485]458        unionfs_dir)
459            [ -d ${BUILD_ROOT} ] || return 1
[5513]460            [ -z "$(mount | grep ${BUILD_ROOT} | egrep '(unionfs|aufs)')" ] || \
[485]461                umount ${BUILD_ROOT}
[5513]462            if [ ! -z "$(mount | grep ${BUILD_ROOT} | egrep '(unionfs|aufs)')" ]; then
[2654]463                echo $"Retry lazy unmount ${BUILD_ROOT} ... "
[485]464                umount -l ${BUILD_ROOT}
[2522]465                echo $"done."
[485]466            fi
467            ;;
[454]468        *)
469            echo mount-chroot-umount: unknown file system $fs
470            exit 1
471            ;;
472    esac
[1240]473    return 0
[412]474}
475
[454]476## mount-chroot-mount [file system|name]
477mount-chroot-mount(){
478    local fs=$1
[412]479
[454]480    case $fs in
481        /home)
[2718]482            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
483            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
484                mount -o _netdev,rbind ${fs} ${BUILD_ROOT}${fs}
[454]485            ;;
[2718]486        /tmp|/dev)
487            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
488            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
489                mount --bind -o _netdev ${fs} ${BUILD_ROOT}${fs}
[454]490            ;;
[2718]491        /sys)
[454]492            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
493            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
[2718]494                mount -o _netdev -t sysfs vbuildersysfs ${BUILD_ROOT}${fs}
[454]495            ;;
[2718]496        /proc)
497            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
498            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
499                mount -o _netdev -t proc vbuilderproc ${BUILD_ROOT}${fs}
500            ;;
501        /dev/shm)
502            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
503            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
504                mount -o _netdev -t tmpfs vbuildertmpfs ${BUILD_ROOT}${fs}
505            ;;
506        /dev/pts)
507            [ -d ${BUILD_ROOT}${fs} ] || mkdir -p ${BUILD_ROOT}${fs}
508            [ -z "$(mount | grep ${BUILD_ROOT}${fs})" ] && \
509                mount -o gid=5,mode=620,_netdev -t devpts vbuilderdevpts ${BUILD_ROOT}${fs}
510            ;;
[454]511        vfs)
[2718]512            for dir in /dev /dev/pts /dev/shm /proc /sys; do
513                mount-chroot-mount ${dir} || return 1
514            done
[454]515            ;;
[725]516        archives_dir)
517            [ -d ${EXTERNAL_ARCHIVES_DIR} ] || mkdir -p ${EXTERNAL_ARCHIVES_DIR}
[454]518            [ -d ${ARCHIVES_DIR} ] || mkdir -p ${ARCHIVES_DIR}
519            [ -z "$(mount | grep ${ARCHIVES_DIR})" ] && \
[2718]520                mount --bind -o _netdev ${EXTERNAL_ARCHIVES_DIR} ${ARCHIVES_DIR}
[454]521            [ -d ${ARCHIVES_DIR}/partial ] || mkdir -p ${ARCHIVES_DIR}/partial
522            ;;
[485]523        unionfs_dir)
524            if [ $with_unionfs -eq 1 ]; then
[2711]525                [ -d ${UNIONFS_ROOT} ] || mkdir -p ${UNIONFS_ROOT}
[5504]526                if ( /sbin/modprobe aufs >& /dev/null ) ; then
527                    [ -z "$(mount | grep ${UNIONFS_ROOT})" ] && \
528                        mount -t aufs -o br=${UNIONFS_ROOT}=rw:${BUILD_ROOT}=ro aufs ${BUILD_ROOT}
529                else
530                    [ -z "$(mount | grep ${UNIONFS_ROOT})" ] && \
531                        mount -t unionfs -o dirs=${UNIONFS_ROOT}=rw:${BUILD_ROOT}=ro unionfs ${BUILD_ROOT}
532                    unionctl ${BUILD_ROOT} --list
533                fi
[485]534            fi
535            ;;
[455]536        *)
537            echo mount-chroot-mount: unknown file system $fs
538            exit 1
539            ;;
[454]540    esac
[1240]541    return 0
[452]542}
[412]543
[5364]544## TODO: support spec-validator
545## spec-validator [spec file]
546spec-validator(){
547    echo
548    return 0
549}
[791]550
[5364]551
[118]552##############################################################################
553
554Clean(){
[1240]555    setup-vbootstrap || return 1
[118]556
[454]557    # mount-chroot --umount /home
[2718]558    mount-chroot --umount /tmp
559    mount-chroot --umount /dev/shm
560    mount-chroot --umount /dev/pts
[3021]561    mount-chroot --umount /proc
[725]562    mount-chroot --umount archives_dir
[485]563    mount-chroot --umount unionfs_dir
[413]564    apt-get-update --host
[406]565
[2770]566    ## We remark that we first remove /, and secondly remove /.
[2769]567    ## If we directly remove /, we obtained some non-empty directories:
568    ##   /dev/.udev/rules.d.
[485]569    if [ $with_unionfs -eq 1 ]; then
[2711]570        if [ -d ${UNIONFS_ROOT} ]; then
571            echo -n $"Cleaning build root ${UNIONFS_ROOT} via unionfs ... "
[2770]572            rm -rf ${UNIONFS_ROOT} 2>/dev/null
[2711]573            rm -rf ${UNIONFS_ROOT}
[2522]574            echo $"done."
[485]575        fi
576    else
577        if [ -d ${BUILD_ROOT} ]; then
[2522]578            echo -n $"Cleaning build root ${BUILD_ROOT} ... "
[2770]579            rm -rf ${BUILD_ROOT} 2>/dev/null
[485]580            rm -rf ${BUILD_ROOT}
[2522]581            echo $"done."
[485]582        fi
[323]583    fi
[412]584
[5364]585    echo $"Cleanup a build farm for ${BUILD_ROOT} done."
[1240]586    return 0
[118]587}
588
589Build(){
[1240]590    setup-vbootstrap || return 1
[118]591
[411]592    if [ $with_dist_upgrade -eq 1 ]; then
593        ## make bootstrap of ${STABLE_VERSION}
594        /usr/sbin/vbootstrap \
[5364]595            $(echo ${BASE_PROFILE} | sed -e "s/VineSeed/${STABLE_VERSION}/") \
[5442]596            ${VBOOTSTRAP_FETCH_URL} ${BUILD_ROOT} 2>&1 | \
597            egrep -v -e '^W: Duplicate sources.list entry' \
598                     -e '^W: .*apt-get update'
[118]599
[411]600        ## aim apt-line to VineSeed
601        sed -i "s/apt ${STABLE_VERSION}/apt VineSeed/g" \
602            ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
603    else
[5442]604        /usr/sbin/vbootstrap \
605            ${BASE_PROFILE} ${VBOOTSTRAP_FETCH_URL} ${BUILD_ROOT} 2>&1 | \
606            egrep -v -e '^W: Duplicate sources.list entry' \
607                     -e '^W: .*apt-get update'
[411]608    fi
609
[2718]610    mount-chroot /proc
[725]611    mount-chroot archives_dir
[2718]612    mount-chroot /dev/pts
613    mount-chroot /dev/shm
[454]614    # mount-chroot /tmp
615    # mount-chroot /home
[118]616
[791]617    ##!! 4.2 has no apt-sourceslist-{plus,nonfree,proposed-updates} packages
[3676]618    case ${VERSION} in
[791]619        4.2)
[5364]620            sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list
621            sed -i -e 's/main plus updates nonfree *$/$(echo ${CATEGORIES} | sed -e "s/,/ /"g) updates/g' ${BUILD_ROOT}/etc/apt/sources.list
622            $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
[800]623            # [ $with_category_security -eq 1 ] && \
624            #   echo
[791]625            ;;
[4530]626        5.2|@@VBUILDER_STABLE_VERSION@@)
[5364]627            sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
628            $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
[791]629            [ $with_category_plus -eq 1 ] && \
[5364]630                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-plus' && \
631                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/plus.list
[791]632            [ $with_category_nonfree -eq 1 ] && \
[5364]633                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-nonfree' && \
634                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/nonfree.list
[791]635            [ $with_category_proposed_updates -eq 1 ] && \
[5364]636                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-proposed-updates' && \
637                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/proposed-updates.list
[800]638            # [ $with_category_security -eq 1 ] && \
639            #   echo
[791]640            ;;
641        VineSeed)
[5364]642            sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/main.list
643            $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
[791]644            [ $with_category_plus -eq 1 ] && \
[5364]645                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-plus' && \
646                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/plus.list
[791]647            [ $with_category_nonfree -eq 1 ] && \
[5364]648                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-nonfree' && \
649                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/nonfree.list
[800]650            [ $with_category_test -eq 1 ] && \
[5364]651                $__chroot_sh 'apt-get -qq update && apt-get -qq -y install apt-sourceslist-test' && \
652                sed -i -e "s|@@VBUILDER_VBOOTSTRAP_FETCH_URL@@|${VBOOTSTRAP_FETCH_URL}|g" ${BUILD_ROOT}/etc/apt/sources.list.d/test.list
[791]653            ;;
654    esac
[423]655
[791]656    [ $with_dist_upgrade -eq 1 ] && \
[464]657        $__chroot_sh 'apt-get -qq update && apt-get -qq -y dist-upgrade'
[791]658
[5508]659    [ $with_build_essential -eq 1 ] && \
660        $__chroot_sh 'apt-get -qq -y install build-essential'
661
[464]662    $__chroot_sh 'apt-get -qq -y install etcskel shadow-utils'
[118]663
[2662]664    $__chroot_sh 'cd /dev && /sbin/MAKEDEV console'
[2718]665    $__chroot_sh 'cd /dev && /sbin/MAKEDEV ptmx'
[2662]666    $__chroot_sh 'cd /dev && /sbin/MAKEDEV null'
667    $__chroot_sh 'cd /dev && /sbin/MAKEDEV zero'
668    $__chroot_sh 'cd /dev && /sbin/MAKEDEV random'
669    $__chroot_sh 'cd /dev && /sbin/MAKEDEV urandom'
[2718]670    $__chroot_sh 'cd /dev && mkdir -p shm && chmod 777 shm'
671    $__chroot_sh 'cd /dev && mkdir -p pts && chmod 755 pts'
[406]672
[453]673    $__chroot_sh '/usr/sbin/pwconv'
674    $__chroot_sh "/usr/sbin/useradd ${BUILD_USER}"
[323]675
[452]676    ##!! for rpm-4.8.0 or higher
677    ##!! (See http://trac.vinelinux.org/wiki/Vine6/AboutUpdateToolchain)
[3676]678    if [ "${VERSION}" = "VineSeed" ]; then
[453]679        $__chroot_sh "sed -i -e 's/^%_topdir/#%_topdir/' /home/${BUILD_USER}/.rpmmacros"
[452]680    fi
681
[5364]682    ## set local repositories (profile only)
683    if [ ${with_profile} -eq 1 ]; then
684        if [ ! -z "${LOCAL_REPOS}" ]; then
685            cat >${BUILD_ROOT}/etc/apt/sources.list.d/local.list<<EOF
686${LOCAL_REPOS}
687EOF
[5510]688        $__chroot_sh "apt-get update"
[5364]689        fi
690
691        ## additional base packages
692        [ ! -z "${ADD_BASE_PKGS}" ] && \
693            $__chroot_sh "apt-get -y install ${ADD_BASE_PKGS}" 
694    fi
695
[454]696    # mount-chroot --umount /home
697    # mount-chroot --umount /tmp
[2718]698    mount-chroot --umount /dev/shm
699    mount-chroot --umount /dev/pts
[725]700    mount-chroot --umount archives_dir
[2718]701    mount-chroot --umount /proc
[413]702    apt-get-update --host
[412]703
[5364]704    echo $"Making a build farm for ${BUILD_ROOT} done."
[1240]705    return 0
[118]706}
707
708RPM_Remove(){
[1240]709    setup-vbootstrap-rpm || return 1
[485]710    mount-chroot unionfs_dir
[725]711    mount-chroot archives_dir
[3021]712    mount-chroot /proc
[2718]713    mount-chroot /dev/pts
714    mount-chroot /dev/shm
[6010]715    # apt-get-update --chroot
[118]716
[2516]717    [ -f $RPM_PKG ] && \
718        echo $"E: $RPM_PKG is not a package name" && return 1
[453]719    $__chroot_sh "apt-get -y remove $BASE_RPM_PKG"
[412]720
[2718]721    mount-chroot --umount /dev/shm
722    mount-chroot --umount /dev/pts
[3021]723    mount-chroot --umount /proc
[725]724    mount-chroot --umount archives_dir
[485]725    mount-chroot --umount unionfs_dir
[6010]726    # apt-get-update --host
[1240]727
728    return 0
[118]729}
730
731RPM_Install(){
[1240]732    setup-vbootstrap-rpm || return 1
[485]733    mount-chroot unionfs_dir
[725]734    mount-chroot archives_dir
[3021]735    mount-chroot /proc
[2718]736    mount-chroot /dev/pts
737    mount-chroot /dev/shm
[413]738    apt-get-update --chroot
[118]739
[4622]740    [ $with_category_nonfree -eq 1 ] && \
741        [ ! -z "$(echo $BASE_RPM_PKG | grep -e 'self-build-' -e 'install-assist-')" ] && \
742        $__chroot_sh 'rpm -q --quiet self-build-setup || apt-get -qq -y install self-build-setup'
743
[453]744    $__chroot_sh "cd ${BUILD_DIR} && apt-get -y install $BASE_RPM_PKG"
[412]745
[2718]746    mount-chroot --umount /dev/shm
747    mount-chroot --umount /dev/pts
[3021]748    mount-chroot --umount /proc
[725]749    mount-chroot --umount archives_dir
[485]750    mount-chroot --umount unionfs_dir
[413]751    apt-get-update --host
[1240]752
753    return 0
[118]754}
755
756RPM_Build(){
[5364]757    [ ! -f ${RPM_PKG} ] && \
758        echo $"E: No such file found: ${RPM_PKG}" && return 1
759
760    ## check the extension of given $RPM_PKG
761    local RPM_PKG_EXT=${RPM_PKG##*.}
762    case ${RPM_PKG_EXT} in
763        spec)
764            ## In this case,
765            ## the file ${RPM_PKG} is a spec file!
766            # spec-validator ${RPM_PKG} || return 1
767            # return 1
768
769            ## We assign the variable ${RPM_PKG}
770            ## the src.rpm generated by the spec file ${RPM_PKG}.
771            RPM_PKG=$(rpm -E "%{_srcrpmdir}")/$(rpm -q --qf "%{name}-%{version}-%{release}\n" --specfile ${RPM_PKG} | head -n 1).src.rpm
772            ;;
773        rpm)
774            RPM_PKG_EXT=$(echo ${RPM_PKG} | sed -e "s|.*\.\(src\.rpm\)$|\1|")
775            [ "${RPM_PKG_EXT}" != "src.rpm" ] && \
776                echo $"E: $RPM_PKG is NOT a source RPM package" && return 1
777            ;;
778        *)
779            echo $"The action build-rpm cannot work such extension: ${RPM_PKG_EXT}"
780            return 1
781            ;;
782    esac
783
[1240]784    setup-vbootstrap-rpm || return 1
[485]785    mount-chroot unionfs_dir
[725]786    mount-chroot archives_dir
[3021]787    mount-chroot /proc
[2718]788    mount-chroot /dev/pts
789    mount-chroot /dev/shm
[628]790    apt-get-update --chroot
[5364]791   
792    [ ! -f ${RPM_PKG} ] && \
793        echo $"E: No such file found: ${RPM_PKG}" && return 1
[118]794
[370]795    RPM_PKG_USER=$(stat -c %U $RPM_PKG)
[371]796    RPM_PKG_GROUP=$(stat -c %G $RPM_PKG)
[520]797    [ ! -z "${SUDO_UID}" ] && RPM_PKG_USER=${SUDO_UID}
798    [ ! -z "${SUDO_GID}" ] && RPM_PKG_GROUP=${SUDO_GID}
[371]799    local __install="install -p -v -o ${RPM_PKG_USER} -g ${RPM_PKG_GROUP}"
[370]800
801    ## make src.rpm for $VERSION
[453]802    $__chroot_sh "cd ${BUILD_DIR} && su ${BUILD_USER} -c 'rpm -ivh $BASE_RPM_PKG'"
[1524]803    $__chroot_sh "cd ${BUILD_DIR} && su ${BUILD_USER} -c 'rpmbuild -bs --nodeps --clean --rmsource --rmspec $RPM_OPTS ${BUILD_DIR}/SPECS/*.spec'"
[370]804
[396]805
806    ## change ${DIST_RELEASE}
[4003]807    BASE_RPM_PKG=$(echo $BASE_RPM_PKG | sed -e "s/vl[0-9]*\([A-Za-z]*[0-9A-Za-z]*\)\./vl${DIST_RELEASE}\1\./")
[396]808
809    ## rebuild $BASE_RPM_PKG on ${DIST_RELEASE}
[969]810    $__chroot_sh "cd ${BUILD_DIR}/SRPMS && apt-get -o APT::Install::Virtual=true -y build-dep $BASE_RPM_PKG"
[453]811    $__chroot_sh "cd ${BUILD_DIR}/SRPMS && su ${BUILD_USER} -c 'rpmbuild --rebuild $RPM_OPTS $BASE_RPM_PKG'"
[4622]812
813    BUILT_RPMS_LIST=$(find $BUILD_ROOT${BUILD_DIR}/RPMS -type f -regex '.*\.rpm' | sed -e s@${BUILD_ROOT}@@g -e 's|.*\/compat32-.*||g' -e 's|.*\/.*\.src\.rpm||g' -e 's/$/ \\/g')
814
815    [ $with_category_nonfree -eq 1 ] && \
816        [ ! -z "$(echo $BUILT_RPMS_LIST | grep -e 'self-build-' -e 'install-assist-')" ] && \
817        $__chroot_sh 'rpm -q --quiet self-build-setup || apt-get -qq -y install self-build-setup'
818
[1267]819    [ $with_no_install -eq 0 ] && \
[4622]820        $__chroot_sh "cd ${BUILD_DIR} && apt-get -y install $BUILT_RPMS_LIST"
[396]821
[370]822    ## copy built rpms to ${HOME}/rpm/ for each archtectures
[2522]823    echo $"Copying built rpms to ${BUILT_RPMS_DIR} for each archtectures ... "
[4076]824    for i in $RPM_PKG_ARCH_LIST; do
825        [ -d $BUILD_ROOT${BUILD_DIR}/${i} ] || continue
826        if [ ! -d ${BUILT_RPMS_DIR}/${VERSION}/${i} ]; then
827            $__install -d ${BUILT_RPMS_DIR}/${VERSION}/${i}/
828            chown -R ${RPM_PKG_USER}:${RPM_PKG_GROUP} ${BUILT_RPMS_DIR}
[370]829        fi
[4076]830        find $BUILD_ROOT${BUILD_DIR}/${i} -type f -regex '.*\.rpm' \
831            -exec $__install -m0644 {} ${BUILT_RPMS_DIR}/${VERSION}/${i}/ \;
[370]832    done
[412]833
[2718]834    mount-chroot --umount /dev/shm
835    mount-chroot --umount /dev/pts
[3021]836    mount-chroot --umount /proc
[725]837    mount-chroot --umount archives_dir
[485]838    mount-chroot --umount unionfs_dir
[413]839    apt-get-update --host
[412]840
[2522]841    echo $"done."
[1240]842    return 0
[118]843}
844
[1240]845RPM_Sign(){
[1375]846    [ $with_sign -eq 1 ] || return 1
[118]847
[2668]848    setup-vbootstrap || return 1
849
850    [ -d ${BUILD_ROOT} ] || Build
851
852    mount-chroot unionfs_dir
853
[2662]854    echo $"Signing built rpms using ${RPM_SIGN_USER}'s key: "
[5364]855    su $RPM_SIGN_USER -c "rpmsign --addsign $(for i in $RPM_PKG_ARCH_LIST; do find $BUILD_ROOT${BUILD_DIR}/${i} -type f -regex '.*\.rpm' 2>/dev/null; done | sed -e s,$BUILD_ROOT${BUILD_DIR},${BUILT_RPMS_DIR}/${VERSION},g -e 's/$/ \\/g')"
[1375]856
[2668]857    mount-chroot --umount unionfs_dir
858
[1240]859    return 0
860}
861
[2718]862Login_Chroot(){
863    [ $with_login -eq 1 ] || return 1
[1240]864
[2718]865    setup-vbootstrap || return 1
866
867    __chroot="/usr/sbin/chroot ${BUILD_ROOT}"
868    ## setarch ix86 if ix86 chroot on x86_64 host
869    [ $with_ix86_on_x86_64 -eq 1 ] && \
870        __chroot="/usr/sbin/chroot ${BUILD_ROOT} setarch ${VARCH}"
871
872
873    mount-chroot unionfs_dir
874    mount-chroot archives_dir
[3021]875    mount-chroot /proc
[2718]876    mount-chroot /dev/pts
877    mount-chroot /dev/shm
878    mount-chroot /tmp
879    # mount-chroot /home
[6010]880    # apt-get-update --chroot
[2718]881
882    ## copy host's configurations of /etc
883    #passwd shadow group gshadow
884    for i in resolv.conf hosts; do
885        cp -pf /etc/${i} ${BUILD_ROOT}/etc
886    done
887    cp -Ppf /etc/localtime ${BUILD_ROOT}/etc
888
[3678]889    $__chroot /bin/bash
[2718]890
891    # mount-chroot  --umount /home
892    mount-chroot  --umount /tmp
893    mount-chroot --umount /dev/shm
894    mount-chroot --umount /dev/pts
[3021]895    mount-chroot --umount /proc
[2718]896    mount-chroot --umount archives_dir
897    mount-chroot --umount unionfs_dir
[6010]898    # apt-get-update --host
[2718]899
900    return 0
901}
902
903
[304]904##############################################################################
905
[5364]906initialize-variables || exit 1
[304]907
[416]908check-parameter $* || exit 1
909
[5364]910setup-vbuilder || exit 1
911
[118]912while [ $# -gt 0 ]; do
[411]913    tmpARG=$1
914    case $tmpARG in
[5364]915        --profile)
[406]916            shift
917            ;;
[5364]918        --version|--arch|--category|--fetch-url|--target|--rpmbuild-define|--rpmbuild-with|--rpmbuild-without|--bootstrap-dir|--unionfs-dir|--cache-dir|--built-rpms-dir)
919            shift
920            ;;
[5508]921        --dist-upgrade|--unionfs|--with-compat32|--sign|--no-install|--login|--no-build-essential|--debug)
[406]922            ;;
[725]923        --build-rpm|build-rpm|--install-rpm|install-rpm|--remove-rpm|remove-rpm)
924            shift
925            ;;
[3675]926        --build|build|--clean|clean)
[725]927            ;;
[406]928        *)
[416]929            echo unknown option $1
[406]930            exit 1
931            ;;
932    esac
933
[411]934    case $tmpARG in
[5364]935        --profile)
936            ;;
[406]937        --version)
[118]938            VERSION=$1
939            ;;
940        --arch)
941            VARCH=$1
942            ;;
[791]943        --category)
944            CATEGORIES=$1
945            ;;
[5364]946        --fetch-url)
947            VBOOTSTRAP_FETCH_URL=$1
948            ;;
[411]949        --dist-upgrade)
950            with_dist_upgrade=1
951            ;;
[485]952        --unionfs)
953            with_unionfs=1
954            ;;
[406]955        --target)
956            TARGET=$1
957            RPM_OPTS="${RPM_OPTS} --target $TARGET"
958            ;;
[118]959        --with-compat32)
[406]960            RPM_OPTS="${RPM_OPTS} --with compat32"
[118]961            ;;
[2531]962        --rpmbuild-define)
963            RPM_OPTS="${RPM_OPTS} --define $1"
964            ;;
[1476]965        --rpmbuild-with)
966            RPM_OPTS="${RPM_OPTS} --with $1"
967            ;;
[2531]968        --rpmbuild-without)
969            RPM_OPTS="${RPM_OPTS} --without $1"
970            ;;
[1240]971        --sign)
972            with_sign=1
973            ;;
[1267]974        --no-install)
975            with_no_install=1
976            ;;
[5508]977        --no-build-essential)
978            with_build_essential=0
979            ;;
[2718]980        --login)
981            with_login=1
982            ;;
[709]983        --bootstrap-dir)
984            VBOOTSTRAP_DIR=$1
985            ;;
[2711]986        --unionfs-dir)
987            UNIONFS_DIR=$1
988            ;;
[725]989        --cache-dir)
990            CACHE_DIR=$1
991            ;;
[709]992        --built-rpms-dir)
993            BUILT_RPMS_DIR=$1
994            ;;
[2718]995        --debug)
996            with_debug=1
997            ;;
[679]998        --build-rpm|build-rpm)
[118]999            RPM_PKG=$1
[406]1000            RPM_Build || exit 1
[118]1001            ;;
[679]1002        --install-rpm|install-rpm)
[118]1003            RPM_PKG=$1
[406]1004            RPM_Install || exit 1
[118]1005            ;;
[679]1006        --remove-rpm|remove-rpm)
[118]1007            RPM_PKG=$1
[406]1008            RPM_Remove || exit 1
[118]1009            ;;
[679]1010        --build|build)
[1240]1011            Build || exit 1
[118]1012            ;;
[679]1013        --clean|clean)
[1240]1014            Clean || exit 1
[118]1015            ;;
1016    esac
1017    shift
1018done
1019
[3479]1020RPM_Sign ||:
[1240]1021
[3479]1022Login_Chroot ||:
[2718]1023
[118]1024exit
Note: See TracBrowser for help on using the repository browser.